#################################################################################
# Demo of Mysund_MDI
# Pure tcl made MS MDI "emulation"
# Usage: of MDI  
# 1) source mdi.tcl in global namespace
# 2) create a frame for MDI-master
# 3) call the procedure ::MDI::master (return value is windowpath to this master)
# 4) calls to procedure ::MDI::slave  (return value is windowpath to this slave)
# 5) do with those windows what ever you want
# further details see the readme.txt
# All these steps are taken care of in this file so....
# type source test.tcl from your wish console
# TODO cascade tile aso. 1 click at minimized...
#################################################################################
destroy .mdi
toplevel .mdi
wm geometry .mdi 800x600+30+30
wm withdraw .
set types {
    {{Text Files}       {.txt}    }
    {{TCL Scripts}      {.tcl}    }
    {{TK Scripts}       {.tk}     }
    {{C Source Files}   {.c}      }
    {{All Files}        *         }}
set prjtypes {{{Project Files} {.prj}} {{All Files} *}}

######
# 1) #
######
source mdi.tcl
######
source ini.tcl
frame .mdi.menu -bd 0 ; pack .mdi.menu -side top -fill x -expand no
      menubutton .mdi.menu.file -bd 0  -pady 2 -text File -underline 0 -menu .mdi.menu.file.menu; pack .mdi.menu.file -side left
                 menu .mdi.menu.file.menu -tearoff false
                 .mdi.menu.file.menu add command -label "New"          -underline 0 -command {::MDI::mditextnew mdi -height 450 -width 300}
                 .mdi.menu.file.menu add command -label "Open"         -underline 0 -command {::MDI::mditextopen mdi}
                 .mdi.menu.file.menu add command -label "Save"         -underline 0 -command {::MDI::mditextsave [::MDI::getcurrent mdi] mdi}
                 .mdi.menu.file.menu add command -label "Save as.."    -underline 5 -command {::MDI::mditextsaveas [::MDI::getcurrent mdi] mdi}
                 .mdi.menu.file.menu add separator
                 .mdi.menu.file.menu add command -label "Preferences"  -underline 1 -command ::MDI::notimplemented
                 .mdi.menu.file.menu add command -label "Print"        -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.file.menu add separator
                 .mdi.menu.file.menu add command -label "Quit"         -underline 0 

      menubutton .mdi.menu.edit -bd 0  -pady 2 -text Edit -underline 0 -menu .mdi.menu.edit.menu; pack .mdi.menu.edit -side left -after .mdi.menu.file
                 menu .mdi.menu.edit.menu -tearoff false
                 .mdi.menu.edit.menu add command -label "Undo"  -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.edit.menu add separator
                 .mdi.menu.edit.menu add command -label "Cut"          -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.edit.menu add command -label "Copy"         -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.edit.menu add command -label "Paste"        -underline 0 -command ::MDI::notimplemented

      menubutton .mdi.menu.project -bd 0 -pady 1 -text Project -underline 0 -menu .mdi.menu.project.menu; pack .mdi.menu.project -side left -after .mdi.menu.edit
                 menu .mdi.menu.project.menu -tearoff false
                 .mdi.menu.project.menu add command -label "Open project"        -underline 0 -command openprj
                 .mdi.menu.project.menu add command -label "Close project"       -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.project.menu add command -label "New project"         -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.project.menu add separator
                 .mdi.menu.project.menu add command -label "Run project"         -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.project.menu add separator
                 .mdi.menu.project.menu add command -label "Add to project"      -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.project.menu add command -label "Delete from project" -underline 0 -command ::MDI::notimplemented
                 .mdi.menu.project.menu add command -label "Edit project file"   -underline 0 -command ::MDI::notimplemented
            
      menubutton .mdi.menu.help -bd 0 -pady 1 -text Help -underline 0 -menu .mdi.menu.help.menu; pack .mdi.menu.help -side right
                 menu .mdi.menu.help.menu -tearoff false
                 .mdi.menu.help.menu add command -label "About"        -underline 0 -command about
                 .mdi.menu.help.menu add command -label "Index"        -underline 0 -command ::MDI::notimplemented


frame .mdi.stat; pack .mdi.stat -side bottom -fill x -expand no
      label .mdi.stat.label -text "Statusbar" -relief sunken -bd 1; pack .mdi.stat.label -side left

######
# 2) #
######
frame .mdi.mdi;  pack .mdi.mdi  -side top -fill both -expand yes 
######

######
# 3) #
######
puts "Master created as [set master1 [MDI::master mdi .mdi.mdi -height 600 -width 900 -menupath .mdi.menu]]"

######

######
# 4) #
######
puts "Slave  created as [set slave1  [MDI::slave cli1 $master1 -height 302 -width 412 -closecmd simpleasthat1 -title "test.tcl"]]"
puts "Slave  created as [set slave2  [MDI::slave cli2 $master1 -height 450 -width 580 -closecmd simpleasthat2 -title "readme.txt"]]"
puts "Slave  created as [set slave3  [MDI::slave cli3 $master1 -height 470 -width 580 -closecmd simpleasthat3 ]]"
######


######
# 5) #
######
scrollbar $slave1.sc -command [subst "$slave1.text yview"]
pack $slave1.sc -fill y -side right
text $slave1.text -wrap none -yscrollcommand [subst "$slave1.sc set"]
pack $slave1.text -fill both -expand yes
scrollbar $slave2.sc -command [subst "$slave2.text yview"]
pack $slave2.sc -fill y -side right
text $slave2.text -wrap none -yscrollcommand [subst "$slave2.sc set"]
pack $slave2.text -fill both -expand yes

set fil [open test.tcl]
$slave1.text insert end [read $fil]
$slave1.text con -state disabled -font {sysfont 8}
close $fil

set fil [open readme.txt]
$slave2.text insert end [read $fil]
$slave2.text con -state disabled -font {sysfont 8}
close $fil
######


proc about {} {
tk_messageBox -message "Mysund_MDI demonstration" -title "About" -icon info -type ok
}
#############################################################################
# closeprocs for slaves: here post a yesno messagebox
# if closeprocs returns 1 its ok to destroy slave, otherwise not
proc simpleasthat1 {args} {
     if {[tk_messageBox -message "Did you read test.tcl carefully?" -title "Close command slave1" -icon warning -type yesno]=="yes"} {
        return 1
        } else {
        return 0}
        }
proc simpleasthat2 {args} {
     if {[tk_messageBox -message "Did you read readme.txt carefully?" -title "Close command slave2" -icon warning -type yesno]=="yes"} {
        return 1
        } else {
        return 0}
        }
proc simpleasthat3 {args} {return 1}
#############################################################################

proc openprj {{args ""}} {
set prjtypes {{{Project Files} {.prj}} {{All Files} *}}
set pname [tk_getOpenFile -filetypes $prjtypes]
if {($args!="") && ![file exists $args]} {
   tk_messageBox -message "\"$args\" is not a valid (project) file" -title "Project file error" -icon error -type ok
   return
   }
if {[set res [getini $pname Mysund project]] != "1"} {
   tk_messageBox -message "\"$pname\" is not a valid project file" -title "Project file error" -icon error -type ok
   return
   } else {
   #puts "project opend"
   global prj
   array set prj [subst {
         files    "[getini $pname project files]"
         open     "[getini $pname project open]"
         source   "[getini $pname project source]"
         saveall  "[getini $pname project saveall]"
         fontall  "[getini $pname preferences fontall]"
         fg       "[getini $pname preferences fg]"
         bg       "[getini $pname preferences bg]"
         }]         
   }   

set path [file dirname $pname]
foreach fil $prj(open) {
puts "prj(opne) $prj(open)"
        if ![file exists $path/$fil] {
            puts "file $path$fil in project doesn't exeist"
            
            } else {
            set curt [::MDI::mditext [::MDI::getnewclientname mdi] mdi -file $path/$fil -title $fil -height 450 -width 300]
            puts $curt   
            $curt configure -font "$prj(fontall)" -bg "$prj(bg)" -fg "$prj(fg)"
            } 
        }
}