proc mditext {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     set clientargs [initmditext $name $parent $args]
     set path [eval [subst {::MDI::slave $name $parent $clientargs}]]
     set textpath [mdisetuptext $path $name $parent]
     return $cstruct(userpath).text.text
}
proc initmditext {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     array set cstruct {
           height   "400"
           width    "400"  
           wrap     "none"  
           title    "No title"
           scroll   "both"
           text     "saved"
           file     ""  
           }
     set res ""
     set args [string range $args 1 [expr [string length $args]-2]]
     foreach {option val} $args {
             switch -- $option {
                    -file   {set cstruct(file)     $val}
                    -wrap   {set cstruct(wrap)     $val}
                    -height {set cstruct(height)   $val}
                    -width  {set cstruct(width)    $val}
                    -title  {set cstruct(title)    $val}
                    -scroll {switch $val {
                                    x       {set cstruct(scroll) $val}
                                    y       {set cstruct(scroll) $val}
                                    both    {set cstruct(scroll) $val}
                                    none    {set cstruct(scroll) $val}
                                    default {set cstruct(scroll) both}
                                    }}
                    default {set res "$res -$option $val"}
                    }
             }
     return [subst {$res -height $cstruct(height) -width $cstruct(width) -title \"$cstruct(title)\" -closecmd \"::MDI::mditextclose $name $parent\"}]
}

proc mdisetuptext {path name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct

   frame $path.bot -bd 0 
   pack  $path.bot -expand no -fill x -side bottom
   pack  $path -expand yes -fill both
   frame $path.text -bd 0
   pack  $path.text -expand yes -fill both
   text  $path.text.text -wrap $cstruct(wrap)
   scrollbar $path.text.scy -command [subst {$path.text.text yview}]
   pack  $path.text.scy -side right -fill y -expand no
   scrollbar $path.bot.scx -orient horizontal -command [subst {$path.text.text xview}]
   pack $path.bot.scx -fill x -side left -expand yes
   pack  $path.text.text -side left -fill both -expand yes
   $path.text.text con -xscrollcommand [subst {$path.bot.scx set}] -yscrollcommand [subst {$path.text.scy set}]

   update idletasks
   frame $path.bot.rect -bd 3 -relief flat -height [lindex [$path.text.scy con -width] 4] -width [lindex [$path.text.scy con -width] 4]
   pack  $path.bot.rect -side right -fill none -expand no

   switch $cstruct(scroll) {
          none {
               pack forget $path.text.scy 
               pack forget $path.bot
               }
          x    {
               pack forget $path.text.scy
               pack forget $path.bot.rect
               }
          y    {pack forget $path.bot}
          }
   bind $path.text.text <KeyRelease> [subst {::MDI::checktextstate %K $name $parent}]
   if {$cstruct(scroll) != "none"} {
      bind $path.text.text <Configure>  [subst {::MDI::checkscrollbar %W $name $parent}]
      bind $path.text.text <KeyRelease> [subst {+::MDI::checkscrollbar %W $name $parent}]
      }
   bind $path.text.text <<Paste>> [subst {::MDI::checktextstate Paste $name $parent}]
   bind $path.text.text <<Cut>>   [subst {::MDI::checktextstate Cut   $name $parent}]
   #bind $path.text.text <<Copy>> [subst {::MDI::checktextstate Copy  $name $parent}]
   #bind $path.text.text <KeyRelease> [subst {::syntext::checkkeyval %K $path}]
   #bind $path.text.text <KeyPress> [subst {::syntext::checkkeyval %K $path}]

   if {[set fname $cstruct(file)] !=""} { 
      if [file exists $fname] {
         set file [open $fname]
         $path.text.text insert end [read $file]
         close $file
         }
      }
   #update idletasks
   ::MDI::checkscrollbar dummy $name $parent
   return $path.text.text
}

proc checkscrollbar {W name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     set path $cstruct(userpath)
     
update idletasks
if {$cstruct(scroll)!="none" && $cstruct(scroll)!="x"} {
   if {("[$path.text.scy get]" == "0.0 1.0")&&( "[winfo viewable $path.text.scy]")} {pack forget $path.text.scy $path.bot.rect}
   if {("[$path.text.scy get]" != "0.0 1.0")&&(!"[winfo viewable $path.text.scy]")} {pack $path.text.scy -side right -fill y -expand no -before $path.text.text; pack $path.bot.rect -side right}
   }
if {$cstruct(scroll)!="none" && $cstruct(scroll)!="y"} {
   if {("[$path.bot.scx  get]" == "0.0 1.0")&&( "[winfo viewable $path.bot.scx ]")} {pack forget $path.bot}
   if {("[$path.bot.scx  get]" != "0.0 1.0")&&(!"[winfo viewable $path.bot.scx ]")} {pack $path.bot -expand no -fill x -side bottom -before $path.text}
   }
}

proc mditextopen {master {fname ""} {types ""}} {
upvar #0 master m
if {$types == ""} {set types {{{Text Files} {.txt}} {{TCL Scripts} {.tcl}} {{TK Scripts} {.tk}} {{C Source Files} {.c}} {{Project Files} {.prj}} {{All Files} * }}}
if {$fname==""} {set fname [tk_getOpenFile -filetypes $types]}
if [file exists $fname] {
   set client [getnewclientname $master]
   if {$client==""} {
      return
      } else {
      ::MDI::mditext $client $master -file $fname -title [file tail $fname]
      }
   }
}

proc getnewclientname {master} {
upvar #0 ::${master}:: ms 
set this ""
set clist $ms(clientlist)
for {set i 1} {$i<25} {incr i} {
    if {[lsearch $clist cli$i]=="-1"} {
       set this cli$i
       break
       }
    }
if {$this!=""} {
   return $this
   } else {
   puts "to many client in one master"
   }
}


proc checktextstate {K name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     if {[lsearch "Alt_l Alt_R Shift_L Shift_R Control_L Control_R Caps_Lock Escape Left Right Up Down Insert Home End Next Prior Pause Num_Lock Clear" $K]=="-1"} {
        set cstruct(text) "modified"
        if {$cstruct(scroll) != "none"} {
           bind $cstruct(userpath).text.text <Configure>  [subst {::MDI::checkscrollbar %W $name $parent}]
           bind $cstruct(userpath).text.text <KeyRelease> ""             
           } else {
           bind $cstruct(userpath).text.text <KeyRelease> ""
           }
        }
}

proc mditextsave {name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct

     if {![info exists cstruct(text)]} {return}
     set file [open $cstruct(file) w]
     if {[string range $file 0 3] == "file"} {
        puts -nonewline $file [$cstruct(userpath).text.text get 0.0 {end -1 chars}]
        close $file
        set cstruct(text) "saved"
        bind $cstruct(userpath).text.text <KeyRelease> [subst {::MDI::checktextstate %K $name $parent}]
        } else {
        set res [tk_messageBox -message "Couldn't save file $fname" -title "Save failed" -icon error -type ok]
        }
}
proc mditextsaveas {name parent {types ""}} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct

     if {![info exists cstruct(text)]} {return}
     if {$types == ""} {set types {{{Text Files} {.txt}} {{TCL Scripts} {.tcl}} {{TK Scripts} {.tk}} {{C Source Files} {.c}} {{Project Files} {.prj}} {{All Files} * }}}
     set fname [tk_getSaveFile -filetypes $types]
     set file [open $fname w]
     if {[string range $file 0 3] == "file"} {
        puts  -nonewline $file [$cstruct(userpath).text.text get 0.0 {end -1 chars}]
        close $file
        set cstruct(text)  "saved"
        set cstruct(file)  "$fname"
        set cstruct(title) "[file tail $fname]"
        $cstruct(path).system.title configure -text "[file tail $fname]"
        bind $cstruct(userpath).text.text <KeyRelease> [subst {::MDI::checktextstate %K $name $parent}]
        } else {
        set res [tk_messageBox -message "Couldn't save file $fname" -title "Save failed" -icon error -type ok]
        }
}
proc mditextclose {name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     if {$cstruct(text) != "saved"} {
        set res [tk_messageBox -message "Save changes to $cstruct(file)?" -title "Save [file tail $cstruct(file)?]" -icon warning -type yesnocancel]
        switch $res {
               yes     {
                       if {$cstruct(file)==""} {
                          ::MDI::mditextsaveas $name $parent
                          } else {
                          ::MDI::mditextsave $name $parent
                          }
                       #$cstruct(path).system.pclose invoke 
                       return 1
                       }
               no      {
                       #$cstruct(path).system.pclose invoke
                       return 1
                       }
               cancel  {return 0}
               default {return 0}
               }
        } else {
        return 1
        }
}
###################################################
#The flow of close commands seems a little unsurten
# at this spot "Taime vill tehl... Taime vill tehl..."
###################################################

proc mditextnew {master {args ""}} {
     set mstructname ::${master}::
     upvar #0 $mstructname mstruct
     ::MDI::mditext [::MDI::getnewclientname $master] $master $args
}

proc mdisettextconfig {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
}
proc mdigettextconfig {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     return "mdigettextconfig not implemented yet"
}

proc notimplemented {{args ""}} {
tk_messageBox -message "This functionallity is not\nimplemented yet" -title "Not implemented" -icon info -type ok
}
